#include <qlayout.h>
#include <klocale.h>
#include <kglobal.h>
#include <kgenericfactory.h>
#include "networkman.h"
#include <kcmodule.h>
#include <kcm.h>
#include <qtranslator.h>
#include <unistd.h>
#include <sys/types.h>


K_PLUGIN_FACTORY(PCBSDNETFactory,
                 registerPlugin<PCBSDKCModule>();
                )
K_EXPORT_PLUGIN(PCBSDNETFactory("kcmpcbsdnetwork"))



PCBSDKCModule::PCBSDKCModule(QWidget  *parent, const QVariantList &list)
   :    KCModule(PCBSDNETFactory::componentData(), parent, list)
{
  setButtons(KCModule::Apply);

  QGridLayout *layout = new QGridLayout(this);

  QString LANG="NetworkManager";
  KGlobal::locale()->insertCatalog(LANG);



  netproc = new NetworkMan();
  netproc->Init();
  if ( ! checkRoot() )
  {
     netproc->setNotRoot();	
  }

  layout->addWidget(netproc);
  netproc->setParent(this);

  connect(netproc, SIGNAL(changed(bool) ), this, SLOT(configChanged() ) );
   
}

PCBSDKCModule::~PCBSDKCModule() {
}


bool    PCBSDKCModule::checkRoot() {
    return (getuid() == 0);
}

int    PCBSDKCModule::buttons() {
   return KCModule::Apply; 
}

void    PCBSDKCModule::load() {
    
}


void    PCBSDKCModule::defaults() {
   //load();
}


void    PCBSDKCModule::save() {
    
   emit changed(FALSE);
}

void    PCBSDKCModule::configChanged() {
	emit changed(TRUE);
}

