#ifndef NETMAN_H
#define NETMAN_H

#include <qdialog.h>
#include <QListWidgetItem>
#include <QProcess>
#include <kmenu.h>
#include "ui_networkman.h"
#include "restartpopup.h"
#include <pcbsd-netif.h>
#include <pcbsd-utils.h>

class NetworkMan : public QDialog, private Ui::NetworkMan
{
        Q_OBJECT

public:
        NetworkMan() : QDialog()
        {
          setupUi(this);
        }

    void setNotRoot();

public slots:
    void Init();

private slots:
    void detectDev();
    void DevSelectionChanged();
    void PropertiesSlot();
    void restartNetwork();
    void refreshDevices();
    void slotSysTray();
    void slotTimerRefresh();
    void slotListRightClick( const QPoint &pos );
    void slotDisableDevice();
    void slotEnableDevice();
    void slotShowInfoConfig();
    void slotDoubleClick( QListWidgetItem * item );
    void slotOpenAdminDlg();
    void loadGlobals();


private:
    QString Devs[100];
    QString DevsIP[100];
    QString DevsStatus[100];
    QString DevsMAC[100];
    QProcess *GetDevList;
    int workingDev;
    QProcess *GetDevName;
    QString DevsName[100];
    QProcess *StartDHCP;
    QProcess *KillDHClient;
    QString DevsNetmask[100];
    restartPopup *restartDialog;
    QString DevsType[100];
    QProcess *ConfigDevice;
    QProcess *ConfigSys;
    QString username;
    int firstUpdate;
    KMenu *popup;
    QString DevsUp[100];
    bool Changed;
    QColor colourWhite;
    QColor colourRed;
    QString getLineFromCommandOutput( QString command );
    QString getNameForIdent( QString ident );
    QString getIpForIdent( QString ident );
    QString getMacForIdent( QString ident );
    QString getStatusForIdent( QString ident );
    bool checkValue( QString File, QString Key, QString Value );
    void runCommand( QString command );
    QString getValue( QString File, QString Key, int occur );
    void saveValue( QString File, QString oldKey, QString newKey, int occur );
    QString getNetmaskForIdent( QString ident );
    bool checkRange( QString IP );
    QString getTypeForIdent( QString ident );
    QString getUpStatusForIdent( QString ident );
    void loadPPPOEConfig();

signals:
	void changed(bool);

} ;
#endif // NETPROPERTIES_H

