#include <qtranslator.h>
#include <qlocale.h>
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <kstandarddirs.h>
#include "netmanadmin.h"

static const char description[] = I18N_NOOP("Network Manager - Admin");

int main( int argc, char ** argv )
{

    KAboutData aboutData("NetManAdmin", 0, ki18n("NetManAdmin"),
                            "1.2", ki18n(description),
                            KAboutData::License_BSD,
                            ki18n("(c) 2008, Kris Moore(c)"));

    aboutData.addAuthor(ki18n("Kris Moore"), ki18n("Current maintainer"), "kris@pcbsd.org");

    KCmdLineArgs::init(argc, argv, &aboutData);

    KCmdLineOptions options;
    options.add("", ki18n("Start the Network Manager"));



    // Tell which options are supported
    KCmdLineArgs::addCmdLineOptions( options );


    KApplication a;
    QLocale Loc;

    QString nlang = Loc.name();

    
    QTranslator translator( 0 );
    translator.load( "NetworkManagerAdmin_" + nlang, KStandardDirs::locate("data", "pc-netmanager/locale/") );
    a.installTranslator( &translator );

    NetworkManAdmin w;

    w.Init();

    w.show();
    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    return a.exec();
}
