/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <iostream>
#include <qtextstream.h>
#include "netmanadmin.h"
#include "ui_netmanadmin.h"
#include <pcbsd-netif.h>
#include <pcbsd-utils.h>
#include <qstring.h>
#include <qfile.h>
#include <qmessagebox.h>

using namespace std;

void NetworkManAdmin::Init()
{
    
    connect(checkPPPOE, SIGNAL(clicked()), this, SLOT(slotPPPOECheckBox()) );
    connect(checkIPv6Enable, SIGNAL(clicked()), this, SLOT(slotIPv6Checked()) );
    connect(pushSave, SIGNAL(clicked()), this, SLOT(save()) );    
    connect(pushCancel, SIGNAL(clicked()), this, SLOT(slotClosed()) );    
    

    // Connect our signal / slots for when the text changes to perform 
    // error checking
    connect(lineDNS1, SIGNAL(textChanged(const QString &)), this, SLOT(slotRecheckText(const QString &) ) );    
    connect(lineDNS2, SIGNAL(textChanged(const QString &)), this, SLOT(slotRecheckText(const QString &) ) );    
    connect(lineGateway, SIGNAL(textChanged(const QString &)), this, SLOT(slotRecheckText(const QString &) ) );    
    connect(lineHostname, SIGNAL(textChanged(const QString &)), this, SLOT(slotRecheckText(const QString &) ) );    
    connect(linePPPUsername, SIGNAL(textChanged(const QString &)), this, SLOT(slotRecheckText(const QString &) ) );    
    connect(linePPPPassword, SIGNAL(textChanged(const QString &)), this, SLOT(slotRecheckText(const QString &) ) );    
    connect(linePPPService, SIGNAL(textChanged(const QString &)), this, SLOT(slotRecheckText(const QString &) ) );    

    // Load our device names for the PPOE combo box
    detectDev();

    // Load any global settings
    loadGlobals();
    
}

void NetworkManAdmin::slotClosed()
{
  close();
}

QString NetworkManAdmin::getLineFromCommandOutput( QString command )
{
	FILE *file = popen(command.toAscii(),"r"); 
	
	char buffer[100];
	
	QString line = ""; 
	char firstChar;
	
	if ((firstChar = fgetc(file)) != -1){
		line += firstChar;
		line += fgets(buffer,100,file);
	}
	
	
	pclose(file);
	
	
	return line;
}


bool NetworkManAdmin::checkValue( QString File, QString Key, QString Value )
{
QFile file( File );
    if ( file.open( QIODevice::ReadOnly ) ) {
        QTextStream stream( &file );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            
               // If the KEY is found in the line, continue processing 
	if ( line.indexOf(Key, 0) != -1)
	{
	    line.remove(line.indexOf(Key, 0), Key.length());
	    if ( line.indexOf(Value, 0) != -1)
	    {
		return TRUE;
	    }
	    
	}
	    
	    
	    
        }
        file.close();
    }
    
    return FALSE;
}


void NetworkManAdmin::runCommand( QString command )
{
	FILE *file = popen(command.toAscii(),"r"); 
	fclose(file);
}


QString NetworkManAdmin::getValue( QString File, QString Key, int occur )
{
     int found = 1;
    
    QFile file( File );
    if ( file.open( QIODevice::ReadOnly ) ) {
        QTextStream stream( &file );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            
               // If the KEY is found in the line, continue processing 
	if ( line.indexOf(Key, 0) != -1 && line.indexOf("#", 0) != 0)
	{
	    if ( found == occur) {
	    
	    line.remove(line.indexOf(Key, 0), Key.length());
	       
	    
	    // Remove any quotes
	    if ( line.indexOf('"') == 0 )
	    {
		line = line.remove(0, 1);
	    }
	    
	    if ( line.indexOf('"') != -1  )
	    {
		line.truncate(line.indexOf('"'));
	    }

	    return line;
	    
	    } else {
	       found++;  
	    }
	    
	    
	}
	    
	    
	    
        }
        file.close();
    }
    
    return "";
    
}


void NetworkManAdmin::saveValue( QString File, QString oldKey, QString newKey, int occur )
{
    // Lets the dev save a value into a specified config file. The occur value tells which occurance of "oldKey" to replace
    // If occur is set to -1, it will remove any duplicates of "oldKey"
    
    
    QString SavedFile;

    int found = 1;
    int wroteKey = 0;
    
    int firstLine = 0;
    
    if ( occur == -1 && newKey.isEmpty() )
    {
	
    }
    
    
    // Load the old file, find the oldKey, remove it and replace with newKey
    QFile file( File );
    if ( file.open( QIODevice::ReadOnly ) ) {
        QTextStream stream( &file );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            
            // If the KEY is found in the line and this matches the occurance that must be processed
            if ( line.indexOf(oldKey, 0) != -1 && wroteKey == 0 && found == occur && line.indexOf("#", 0) != 0)
           {
	   if ( firstLine == 0) {
		
	    SavedFile = SavedFile + newKey;
	    found++;
	    firstLine = 1;
	    } else {
	    SavedFile = SavedFile + "\n" + newKey;
	    found++;	
	    wroteKey = 1;
	    }
	    
	  // If the KEY is found, and we are just on wrong occurance, save it and continue to search  
            } else if (line.indexOf(oldKey, 0) != -1 && occur != -1 && found != occur && line.indexOf("#", 0) != 0 ) {
	    if ( firstLine == 0) {
	         SavedFile = SavedFile + line ;
                        firstLine = 1;
	     } else {
	         SavedFile = SavedFile + "\n" + line ;     
                   }
	     
	found++;
	
	
             // if we are trying to remove the key, don't save it	
            } else if (line.indexOf(oldKey, 0) != -1 && occur == -1 && newKey.isEmpty() && line.indexOf("#", 0) != 0 ) {
	
             // We just want one occurance of the key
            } else if (line.indexOf(oldKey, 0) != -1 && occur == -1 && ! newKey.isEmpty() && line.indexOf("#", 0) != 0 ) {
	   if ( firstLine == 0) {
	       SavedFile = SavedFile + newKey;
	       found++;
	       firstLine = 1;
	    } else {
		SavedFile = SavedFile + "\n" + newKey;
		found++;	
		wroteKey = 1;
	    }
	    
	    
	// String not found at all
            } else {
	    
	    if ( firstLine == 0) {
	         SavedFile = SavedFile + line ;
                        firstLine = 1;
	     } else {
	         SavedFile = SavedFile + "\n" + line ;     
                   }
	}
	    
	    
	    
        }
	// Didnt find the key? Write it!
	if ( wroteKey == 0 && ! newKey.isEmpty())
	{
	    SavedFile = SavedFile + "\n" + newKey;
	}
	
        file.close();
    }
    
    
    // Save the new file
    QFile fileout( File );
    if ( fileout.open( QIODevice::WriteOnly ) ) {
        QTextStream streamout( &fileout );
                    streamout << SavedFile;
        fileout.close();
    }
    
}


void NetworkManAdmin::loadGlobals()
{    
    QString tmp;
    lineHostname->setText(getValue("/etc/rc.conf", "hostname=", 1));
    lineGateway->setText(getValue("/etc/rc.conf", "defaultrouter=", 1) );
    lineDNS1->setText(getValue("/etc/resolv.conf", "nameserver", 1) );
    lineDNS2->setText(getValue("/etc/resolv.conf", "nameserver", 2) );

    // Check for IPv6 settings
    tmp = getValue("/etc/rc.conf", "ipv6_enable=", 1) ;
    if ( tmp == "YES" ) {
	checkIPv6Enable->setChecked(TRUE);
	lineIPv6Gateway->setEnabled(TRUE);
    } else {
	checkIPv6Enable->setChecked(FALSE);
	lineIPv6Gateway->setEnabled(FALSE);
    }
    
    lineIPv6Gateway->setText(getValue("/etc/rc.conf", "ipv6_defaultrouter=", 1) );
    
    
    
    // Load the PPPOE Configuration

    if ( QFile::exists( "/etc/ppp/ppp.conf" ) )
   {
       loadPPPOEConfig();
   }
	
    // See if we need to enable the PPPOE group box
    slotPPPOECheckBox();
    
}


bool NetworkManAdmin::checkRange( QString IP )
{
    
    int num;
    
    num = IP.section(".", 0,0).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
   num = IP.section(".", 1,1).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
    
    num = IP.section(".", 2,2).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
   num = IP.section(".", 3,3).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
    return TRUE;
    

}

void NetworkManAdmin::save()
{
    
    saveValue("/etc/rc.conf", "hostname=", "hostname=\"" + lineHostname->text() + "\"", -1);
    saveValue("/etc/hosts", "::1", "::1\t\t\tlocalhost localhost.localdomain " + lineHostname->text() + ".localhost " + lineHostname->text(), -1);
    saveValue("/etc/hosts", "127.0.0.1", "127.0.0.1\t\tlocalhost localhost.localdomain " + lineHostname->text() + ".localhost " + lineHostname->text(), -1);
    
    
    if ( lineGateway->text() == "..." ) {
     saveValue("/etc/rc.conf", "defaultrouter=", "", -1);
   } else {
     saveValue("/etc/rc.conf", "defaultrouter=", "defaultrouter=\"" + lineGateway->text() + "\"", -1);  
   }
   
   int DNSline = 1;
   
   
    if ( lineDNS1->text() == "..." ) {
     saveValue("/etc/resolv.conf", "nameserver", "", DNSline);
   } else {
     saveValue("/etc/resolv.conf", "nameserver", "nameserver " + lineDNS1->text(), DNSline);  
     DNSline++;
   }   
    if ( lineDNS2->text() == "..." ) {
     saveValue("/etc/resolv.conf", "nameserver", "", DNSline);
   } else {
     saveValue("/etc/resolv.conf", "nameserver", "nameserver " + lineDNS2->text(), DNSline);  
   }   
   
    if (checkPPPOE->isChecked())
   {
	savePPPOEConfig();
   } else {
	disablePPPOEConfig();
   }
   
   // Save the IPv6 stuff
    if ( checkIPv6Enable->isChecked() ) {
	
	saveValue("/etc/rc.conf", "ipv6_enable=", "ipv6_enable=\"YES\"", -1);
	saveValue("/etc/rc.conf", "ipv6_defaultrouter=", "ipv6_defaultrouter=\"" + lineIPv6Gateway->text() + "\"", -1);
    } else {
	saveValue("/etc/rc.conf", "ipv6_enable=", "", -1);
	saveValue("/etc/rc.conf", "ipv6_defaultrouter=", "", -1);
    }
   
    restartNetwork();
    close();
}


void NetworkManAdmin::slotCheckGlobalText()
{
   // Disable the save button until we ensure the data is ready to go
   pushSave->setEnabled(FALSE);

   QRegExp hostnameRegExp("^(([a-z0-9][a-z0-9-]*[a-z0-9])|([a-z0-9]+))$");
   textGlobalError->setText("");
  
     if ( lineDNS1->text() != "..."  && ! checkRange(lineDNS1->text() ) ) {
	 QMessageBox::warning( this, tr("Warning"),
	  tr("DNS #1 is out of range! (") + lineDNS1->text() + tr(") Fields must be between 0-255.") );
	 return;
     }
    
    if ( lineDNS2->text() != "..."  && ! checkRange(lineDNS2->text() ) ) {
	 QMessageBox::warning( this, tr("Warning"),
	  tr("DNS #2 is out of range! (") + lineDNS2->text() + tr(") Fields must be between 0-255.") );
	 return;
     }
    
    
     if ( lineGateway->text() != "..."  && ! checkRange(lineGateway->text() ) ) {
	 QMessageBox::warning( this, tr("Warning"),
	  tr("Gateway is out of range! (") + lineGateway->text() + tr(") Fields must be between 0-255.") );
	 return;
     }
     
     /**
     Hostnames must:
     - Contain only a-z, 0-9, and hyphens (-)
     - Not have a hyphen as the first or last character
     **/
     lineHostname->setText(lineHostname->text().toLower());
     if (lineHostname->text().isEmpty())
     {
       textGlobalError->setText(tr("Please enter a hostname"));
       return;
     }
     else if (hostnameRegExp.indexIn(lineHostname->text()) == -1)
     {
        textGlobalError->setText(tr("Hostname may only contain letters and numbers"));
	return;
     }



   // Check if we need to validate the PPPOE data
   if ( groupBoxPPPOE->isEnabled() )
   {
      if (linePPPUsername->text().isEmpty() )
      {
        textGlobalError->setText(tr("Missing a PPPOE username!"));
        return;
      }

      if (linePPPPassword->text().isEmpty() )
      {
        textGlobalError->setText(tr("Missing a PPPOE password!"));
        return;
      }
   }

   pushSave->setEnabled(TRUE);
     
}


void NetworkManAdmin::slotPPPOECheckBox()
{
   // Check if we need to enable the PPPOE groupbox or not
   if ( ! checkPPPOE->isChecked() ) {
       groupBoxPPPOE->setEnabled(FALSE);
   } else {
       groupBoxPPPOE->setEnabled(TRUE);
   }

   slotCheckGlobalText();
}


void NetworkManAdmin::loadPPPOEConfig()
{
    
    
     int foundProfile = 0;
     QString ProfileName = "internet";
     QString tmp, tmp2;
     
     // Check to see if PPPoE is enabled
     tmp = getValue( "/etc/rc.conf", "ppp_enable=", 1 );
     if ( tmp == "YES" ) {
     checkPPPOE->setChecked(TRUE); 
     }



   	// Start loading the rc.conf information
   	tmp = getValue( "/etc/rc.conf", "ppp_mode=", 1 );
	if ( tmp == "ddial" ) {
		checkPPPAlwaysOn->setChecked(TRUE);
	}
   	tmp = getValue( "/etc/rc.conf", "ppp_nat=", 1 );
	if ( tmp == "YES" ) {
		checkPPPNat->setChecked(TRUE);
	}

	// Now load the ppp.conf file
        QString PPPFile = "/etc/ppp/ppp.conf";
        QFile filein( PPPFile );
	if ( filein.open( QIODevice::ReadOnly ) ) {
        QTextStream stream( &filein );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'


	    // Check if we are on a profile line
	    if ( line.indexOf(":") == line.length() -1 ) {
		if ( line.indexOf("default") == -1 ) {
		    // If we find the existing profile for this device, remove it
		    foundProfile = 1;
		    
		} else {
		    foundProfile = 0;
		}
	    }

	    if ( foundProfile == 1)
	    {
		// Search for the username and load it
		if ( line.indexOf("authname") != -1 )
		{
			tmp = line.remove(0, line.indexOf("authname") + 9 );
			linePPPUsername->setText(tmp);
		}
		// Search for the password and load it
		if ( line.indexOf("authkey") != -1 )
		{
			tmp = line.remove(0, line.indexOf("authkey") + 8 );
			linePPPPassword->setText(tmp);
		}
		
		// Search for the device / service tag
		if ( line.indexOf("set device PPPoE:") != -1 )
		{
		    tmp = line.remove(0, line.indexOf("set device PPPoE:") + 18 );
		    
		    // Search for the service tag in remainder line
		    if ( tmp.indexOf(":") != -1 ) {
			tmp2 = tmp.remove(0, tmp.indexOf(":") + 1 );
			linePPPService->setText(tmp2);
			tmp.truncate( tmp.indexOf(":") );
		    }
		    
		}
	    } // Found a profile

	} 
    } 

}


void NetworkManAdmin::savePPPOEConfig()
{
        // Make or update the entry in the /etc/ppp.conf file
        updatePPPconf();

        saveValue( "/etc/rc.conf", "ppp_enable", "ppp_enable=\"YES\"", -1);
        if ( checkPPPAlwaysOn->isChecked() ) {
		saveValue( "/etc/rc.conf", "ppp_mode", "ppp_mode=\"ddial\"", -1);
	} else {
		saveValue( "/etc/rc.conf", "ppp_mode", "ppp_mode=\"background\"", -1);
	}
        if ( checkPPPNat->isChecked() ) {
		saveValue( "/etc/rc.conf", "ppp_nat", "ppp_nat=\"YES\"", -1);
	} else {
		saveValue( "/etc/rc.conf", "ppp_nat", "ppp_nat=\"NO\"", -1);
	}
	
	saveValue( "/etc/rc.conf", "ppp_profile", "ppp_profile=\"" + linePPPService->text() + "\"", -1);
}


void NetworkManAdmin::updatePPPconf()
{
    
     QString DeviceName = comboPPPOEDev->currentText();
    
     QFile filein( "/etc/ppp/ppp.conf" );
     QFile fileout( "/etc/ppp/ppp.conf" );
     QString SavedFile;
     QString ProfileName = linePPPService->text();


     SavedFile = "default:\n set timeout 180\n enable dns\n\n" + ProfileName + ":\n  set device PPPoE:" + DeviceName + ":" + ProfileName + "\n  set authname " + linePPPUsername->text() + "\n  set authkey " + linePPPPassword->text() + "\n  set dial\n  set login\n  set ifaddr 0 0\n  add default HISADDR";

    if ( fileout.open( QIODevice::WriteOnly ) ) {
        QTextStream streamout( &fileout );
                    streamout << SavedFile;
        fileout.close();
    }


    runCommand("chmod 755 /etc/ppp/ppp.conf");
    
}


void NetworkManAdmin::disablePPPOEConfig()
{
	// Update the ppp.conf file to remove any old profile information
	updatePPPconf();
	saveValue( "/etc/rc.conf", "ppp_enable", "", -1);
	saveValue( "/etc/rc.conf", "ppp_mode", "", -1);
	saveValue( "/etc/rc.conf", "ppp_nat", "", -1);
	saveValue( "/etc/rc.conf", "ppp_profile", "", -1);
}


void NetworkManAdmin::slotPPPOEChanged()
{
    // Run the check to see if we need to enable the apply button
    slotCheckGlobalText();
}


void NetworkManAdmin::slotIPv6Checked()
{
    
    if ( checkIPv6Enable->isChecked() ) {
	lineIPv6Gateway->setEnabled(TRUE);
    } else {
	lineIPv6Gateway->setEnabled(FALSE);
    }

   slotCheckGlobalText();
}


void NetworkManAdmin::restartNetwork()
{
    //Set the hostname
    runCommand("hostname " + lineHostname->text());

   // Set the gateway device name
   if ( lineGateway->text() != "..."  ) {
        runCommand("route flush ; route add default " + lineGateway->text() );
   }

   if ( checkPPPOE->isChecked() ) {
      runCommand("/etc/rc.d/ppp restart &");
   } else {
      runCommand("/etc/rc.d/ppp stop &");
   }
}

void NetworkManAdmin::slotRecheckText(const QString &text)
{
   slotCheckGlobalText();
}


void NetworkManAdmin::detectDev()
{
   QString Devs[100], DevsType[100];
   
    QStringList ifs = NetworkInterface::getInterfaces();
    uint i = 0;
    for ( QStringList::Iterator it = ifs.begin(); it != ifs.end(); ++it )
    {
       QString dev = *it;
       if (dev.indexOf("lo0") == -1
           && dev.indexOf("fwe") == -1
           && dev.indexOf("plip") == -1
           && dev.indexOf("pfsync") == -1
           && dev.indexOf("pflog") == -1
           && dev.indexOf("tun") == -1)
       {
           Devs[i] = dev;
           // Determine if its a wireless or wired device
           DevsType[i] = getTypeForIdent(Devs[i]);

           if ( DevsType[i] != "Wireless" ) comboPPPOEDev->addItem(Devs[i]);
      i++;
       }
   }
}


QString NetworkManAdmin::getTypeForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   if (ifr.isWireless()) return "Wireless";
   return "Ethernet";
}

