#ifndef NETMANADMIN_H
#define NETMANADMIN_H

#include <qdialog.h>
#include "ui_netmanadmin.h"

class NetworkManAdmin : public QDialog, private Ui::NetworkManAdmin
{
        Q_OBJECT

public:
        NetworkManAdmin() : QDialog()
        {
          setupUi(this);
        }

public slots:
    void Init();
    void save();
    void slotCheckGlobalText();
    void slotPPPOECheckBox();

private slots:
    void slotIPv6Checked();
    void slotClosed();
    void slotPPPOEChanged();
    void slotRecheckText(const QString &text);


private:
    void runCommand( QString command );
    void restartNetwork();
    QString getLineFromCommandOutput(QString command);
    QString getValue( QString File, QString Key, int occur );
    void saveValue( QString File, QString oldKey, QString newKey, int occur );
    void loadGlobals();
    bool checkRange( QString IP );
    bool checkValue( QString File, QString Key, QString Value );
    void loadPPPOEConfig();
    void savePPPOEConfig();
    void updatePPPconf();
    void disablePPPOEConfig();
    void detectDev();
    QString getTypeForIdent( QString ident );
signals:

} ;
#endif // NETMANADMIN_H

