// QT Includes
#include <qpair.h>
#include <QProcess>

// KDE Includes
#include <ksystemtrayicon.h>


class QString;
class QPixmap;

class NetworkTray : public KSystemTrayIcon {
   Q_OBJECT
   
public:
   NetworkTray() : KSystemTrayIcon()
   {

   }
   void programInit(QString, QString);
   
   virtual ~NetworkTray() {};
   
private slots:
   void openNetManager();
   void openDeviceInfo();
   void openConfigDlg();
   void monitorStatus();
   void slotRestartNetwork();
   void slotEnablePPPOE();
   void slotDisablePPPOE();
   void slotTrayActivated(QSystemTrayIcon::ActivationReason);

   
private:
   void displayTooltip();
   QString getLineFromCommandOutput( QString command );
   QString getNameForIdent( QString ident );
   QString getIpForIdent( QString ident );
   QString getMacForIdent( QString ident );
   QString getStatusForIdent( QString ident );
   QString getSSIDForIdent( QString ident );
   QString getNetmaskForIdent( QString ident );
   QString getSignalStrengthForIdent( QString ident );
   QString getWirelessSpeedForIdent( QString ident );
   QString getValue( QString File, QString Key, int occur );
   QString getUpStatusForIdent( QString ident );
   QString getMediaForIdent( QString ident );
   QString getIPv6ForIdent( QString ident );
   QString getGatewayForIdent( QString ident );
   QProcess *runCommandProc;

};
