/***************************************************************************
 *   Copyright (C) 2007 by Kris Moore   *
 *   kris@pcbsd.com   *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. *
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/
#include <qdialog.h>
#include <qwidget.h>
#include "ui_ethernetconfig.h"

#ifndef _ETHERNETCONFIG_H_
#define _ETHERNETCONFIG_H_


class ethernetconfig : public QDialog, private Ui::ethernetconfig
{
    Q_OBJECT

public:
    ethernetconfig() : QDialog()
    {
	setupUi(this);
    }

    virtual void setDevice(QString Device);
    virtual void showInfo();
    virtual void programInit();
    virtual bool checkRange(QString IP);

public slots:
    virtual void slotIPCheckbox();
    virtual void slot_apply();
    virtual void slot_close();
    virtual void slotDisableCheck();
    virtual void slotOK();
    virtual void slotIPv6clicked();
    virtual void slotMacClicked();


private:
    virtual void runCommand( QString command );
    virtual void saveValue( QString File, QString oldKey, QString newKey, int occur );
    virtual QString getValue( QString File, QString Key, int occur );
    virtual QString getNetmaskForIdent( QString ident );
    virtual QString getOutErrorsForIdent(QString ident);
    virtual QString getOutPacketsForIdent(QString ident);
    virtual QString getInErrorsForIdent(QString ident);
    virtual QString getInPacketsForIdent(QString ident);
    virtual QString getStatusForIdent( QString ident );
    virtual QString getMacForIdent( QString ident );
    virtual QString getIpForIdent( QString ident );
    virtual QString getNameForIdent( QString ident );
    virtual QString getLineFromCommandOutput( QString command );
    virtual QString getGatewayForIdent(QString ident);
    virtual QString getIPv6ForIdent(QString ident);
    virtual QString getMediaForIdent( QString ident );
    

private slots:
    virtual void loadInfo();
    virtual void slotFinishLoad();
    virtual void slotCheckGlobalText(const QString &text );
};

#endif

