#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <qtranslator.h>
#include <kstandarddirs.h>
#include <qtextcodec.h>
#include "wificonfigwidgetbase.h"
#include "ui_wificonfigwidgetbase.h"

static const char description[] = I18N_NOOP("WIFI Setup GUI");

int main( int argc, char ** argv )
{

   KAboutData aboutData("WIFIGUI", 0, ki18n("WIFIGUI"),
                            "1.2", ki18n(description),
                            KAboutData::License_BSD,
                            ki18n("(c) 2008, Kris Moore(c)"));

    aboutData.addAuthor(ki18n("Kris Moore"), ki18n("Current maintainer"), "kris@pcbsd.org");

    KCmdLineArgs::init(argc, argv, &aboutData);

    KCmdLineOptions options;
    options.add("+<device>", ki18n("Start the Network configuration on specified wireless device"));
    options.add("info <device>", ki18n("Show the info tab on the specified wireless device."));



    // Tell which options are supported
    KCmdLineArgs::addCmdLineOptions( options );


    KApplication a;

 
    QTranslator translator( 0 );
    QLocale mylocale(0);
    translator.load( "wificonfig_" + mylocale.language(), KStandardDirs::locate("data", "pc-netmanager/locale/") );
    a.installTranslator( &translator );

    wificonfigwidgetbase w;
    //a.setMainWidget(&w);
    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    
    if ( argc == 2)
    {
		QString Device = argv[1];
		w.setDevice(Device);
		w.show();
     } else if ( argc == 3  ) {
	 QString val = argv[1];
	 if ( val != "info" ) {
	   exit(1);  
	 }
	 
	 QString Device = argv[2];
	 w.setDevice(Device);
	 w.showInfo();
	 w.show();
     } else {
		exit(1);
     }

    return a.exec();
}
