/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include "wificonfigwidgetbase.h"
#include "ui_wificonfigwidgetbase.h"
#include <QFile>
#include <qtextstream.h>
#include <unistd.h>


void wificonfigwidgetbase::slotClose()
{
    exit(0);
}


void wificonfigwidgetbase::slotApply()
{
    QString tmp;
    QString ifConfigLine;
  
    if ( ! pushApply->isEnabled() ) {
	return;
    }
    
    // If the user disabled the device, do so now
    if ( checkDisableWireless->isChecked() )
    {
	 saveValue( "/etc/rc.conf", "ifconfig_" + DeviceName, "", -1);
	 runCommand("ifconfig " + DeviceName + " down");
         pushApply->setEnabled(FALSE);
	 return;
    }
    
    
    if (! checkDHCP->isChecked() )
    {
	if ( lineIP->text() == "..." || lineNetmask->text() == "..." )
	{
	    QMessageBox::information( this, tr("Missing Fields"),
                    tr("You must enter an IP and Netmask to continue!\n") );
	    
	    return;
	}
	
	if ( ! checkRange(lineIP->text() ) ) {
	    QMessageBox::warning( this, tr("Warning"),
	    tr("IP Address is out of range! (") + lineIP->text() + tr(") Fields must be between 0-255.") );
	   return;
               }
	
	if ( ! checkRange(lineNetmask->text() ) ) {
	    QMessageBox::warning( this, tr("Warning"),
	    tr("Netmask is out of range! (") + lineNetmask->text() + tr(") Fields must be between 0-255.") );
	   return;
               }
	
	if ( checkMAC->isChecked() ) { 
	    ifConfigLine="inet " + lineIP->text() + " netmask " + lineNetmask->text();
	} else {
	    ifConfigLine="inet " + lineIP->text() + " netmask " + lineNetmask->text() + " ether " + lineMAC->text();
	}
	
	
	
    } else {
	ifConfigLine="DHCP";
    }
	
    saveValue( "/etc/rc.conf", "ifconfig_" + DeviceName, "ifconfig_" + DeviceName + "=\"WPA " + ifConfigLine + "\"", -1);
	
    // Now create the wpa_supplicant file based on saved configuration
    QFile fileout( "/etc/wpa_supplicant.conf" );
    if ( fileout.open( QIODevice::WriteOnly ) ) {
       QTextStream streamout( &fileout );

       // Loop through all the devices we have now
       for(int curItem=0; curItem < 145; curItem++)
       {
         if ( ! SSIDList[curItem].isEmpty() )
         {




       if ( BSSID[curItem]) {
          streamout << "network={\n bssid=" + SSIDList[curItem] + "\n";
       } else {
         streamout << "network={\n ssid=\"" + SSIDList[curItem] + "\"\n";
       }

       streamout << " priority=" << 145 - curItem << "\n";
       streamout << " scan_ssid=1\n";

       if ( SSIDEncType[curItem] == NO_ENCRYPTION )
       {
          streamout << " key_mgmt=NONE\n";
       } else if (SSIDEncType[curItem] == WEP_ENCRYPTION ) {
          
          streamout << " key_mgmt=NONE\n";
          streamout << " wep_tx_keyidx=" + tmp.setNum(WEPIndex[curItem]) + "\n";
          // Check if we are using a plaintext WEP or not
          if ( WEPHex[curItem] ) {
            streamout << " wep_key" + tmp.setNum(WEPIndex[curItem]) + "=" + WEPKey[curItem] + "\n";
          } else {
            streamout << " wep_key" + tmp.setNum(WEPIndex[curItem]) + "=\"" + WEPKey[curItem] + "\"\n";
          }

       } else if (SSIDEncType[curItem] == WPA_ENCRYPTION ) {

          streamout << " psk=\"" + WPAPersonalKey[curItem] + "\"\n";	

       } else if (SSIDEncType[curItem] == WPAE_ENCRYPTION ) {

          if ( WPAEType[curItem] == 1) {
             streamout << " proto=RSN\n key_mgmt=WPA-EAP\n eap=TLS\n";
	     streamout << " identity=\"" + WPAEIdent[curItem] + "\"\n";
	     streamout << " ca_cert=\"" + WPAECACert[curItem] + "\"\n";
	     streamout << " client_cert=\"" + WPAEClientCert[curItem] + "\"\n";
	     streamout << " private_key=\"" + WPAEPrivKeyFile[curItem] + "\"\n";
	     streamout << " private_key_password=\"" + WPAEPassword[curItem] + "\"\n";

	  } else if (WPAEType[curItem] == 2) {
	     streamout << " proto=RSN\n key_mgmt=WPA-EAP\n eap=TTLS\n";
	     streamout << " identity=\"" + WPAEIdent[curItem] + "\"\n";
	     streamout << " password=\"" + WPAEPassword[curItem] + "\"\n";
	     streamout << " ca_cert=\"" + WPAECACert[curItem] + "\"\n";
	     streamout << " phase2=\"auth=MD5\"\n";
	  
	  } else if (WPAEType[curItem] == 3) {
	     streamout << " proto=RSN\n key_mgmt=WPA-EAP\n eap=PEAP\n";
	     streamout << " identity=\"" + WPAEIdent[curItem] + "\"\n";
	     streamout << " password=\"" + WPAEPassword[curItem] + "\"\n";
	     streamout << " ca_cert=\"" + WPAECACert[curItem] + "\"\n";
	     streamout << " phase1=\"peaplabel=0\"\n";
	     streamout << " phase2=\"auth=MSCHAPV2\"\n";
          }
       }

       streamout << "}\n\n";

         } // End of if check if SSIDList is empty
       } // End of for loop

       fileout.close();
     } 

    
   // Now restart the network for new settings to take effect
   QFile filerestart( "/tmp/.netrestart.sh" );
   if ( filerestart.open( QIODevice::WriteOnly ) ) {
	QTextStream streamrestart( &filerestart );
	streamrestart << "#!/bin/sh\n";
	streamrestart << "/etc/rc.d/netif restart " << DeviceName << "\n";
	//streamrestart << "/etc/rc.d/routing restart";	
	filerestart.close();
   }


   runCommand("chmod 755 /tmp/.netrestart.sh ; sh /tmp/.netrestart.sh");
     
   pushApply->setEnabled(FALSE);
}


void wificonfigwidgetbase::slotCheckDHCPBox()
{
       if ( checkDHCP->isChecked() ) {
	groupBoxIP->setEnabled(FALSE);
   } else {
	groupBoxIP->setEnabled(TRUE);
   }
   
    pushApply->setEnabled(TRUE);
}


// Function which is called at the program init
void wificonfigwidgetbase::setDevice( QString Device )
{ 
    
  // Connect our add / remove buttons for wifi
  connect( pushDown, SIGNAL( clicked() ), this, SLOT( slotMoveDown() ) ); 
  connect( pushUp, SIGNAL( clicked() ), this, SLOT( slotMoveUp() ) ); 
  connect( pushAddWifi, SIGNAL( clicked() ), this, SLOT( slotAddNewProfile() ) ); 
  connect( pushEditWifi, SIGNAL( clicked() ), this, SLOT( slotEditProfile() ) ); 
  connect( pushRemoveWifi, SIGNAL( clicked() ), this, SLOT( slotRemoveProfile() ) ); 


  // Save the device name for later
  DeviceName = Device;

  // Center the dialog window
 QDesktopWidget *d = QApplication::desktop();
 move(d->width() / 3, d->height() / 4);
 
  // Connect the slot to refresh
  QTimer::singleShot(100,  this,  SLOT(slotFinishLoading() ) );
  
 
}


bool wificonfigwidgetbase::checkRange( QString IP )
{
int num;
    
    num = IP.section(".", 0,0).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
   num = IP.section(".", 1,1).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
    
    num = IP.section(".", 2,2).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
   num = IP.section(".", 3,3).toInt();
    
    if ( num > 255 || num < 0)
    {
	return false;
    }
    
    return TRUE;
}


void wificonfigwidgetbase::saveValue( QString File, QString oldKey, QString newKey, int occur )
{
     // Lets the dev save a value into a specified config file. The occur value tells which occurance of "oldKey" to replace
    // If occur is set to -1, it will remove any duplicates of "oldKey"
    
    
    QString SavedFile;

    int found = 1;
    int wroteKey = 0;
    
    int firstLine = 0;
    
    if ( occur == -1 && newKey.isEmpty() )
    {
	
    }
    
    
    // Load the old file, find the oldKey, remove it and replace with newKey
    QFile file( File );
    if ( file.open( QIODevice::ReadOnly ) ) {
        QTextStream stream( &file );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            
            // If the KEY is found in the line and this matches the occurance that must be processed
            if ( line.indexOf(oldKey, 0) != -1 && wroteKey == 0 && found == occur && line.indexOf("#", 0) != 0)
           {
	   if ( firstLine == 0) {
		
	    SavedFile = SavedFile + newKey;
	    found++;
	    firstLine = 1;
	    } else {
	    SavedFile = SavedFile + "\n" + newKey;
	    found++;	
	    wroteKey = 1;
	    }
	    
	  // If the KEY is found, and we are just on wrong occurance, save it and continue to search  
            } else if (line.indexOf(oldKey, 0) != -1 && occur != -1 && found != occur && line.indexOf("#", 0) != 0 ) {
	    if ( firstLine == 0) {
	         SavedFile = SavedFile + line ;
                        firstLine = 1;
	     } else {
	         SavedFile = SavedFile + "\n" + line ;     
                   }
	     
	found++;
	
	
             // if we are trying to remove the key, don't save it	
            } else if (line.indexOf(oldKey, 0) != -1 && occur == -1 && newKey.isEmpty() && line.indexOf("#", 0) != 0 ) {
	
             // We just want one occurance of the key
            } else if (line.indexOf(oldKey, 0) != -1 && occur == -1 && ! newKey.isEmpty() && line.indexOf("#", 0) != 0 ) {
	   if ( firstLine == 0) {
	       SavedFile = SavedFile + newKey;
	       found++;
	       firstLine = 1;
	    } else {
		SavedFile = SavedFile + "\n" + newKey;
		found++;	
		wroteKey = 1;
	    }
	    
	    
	// String not found at all
            } else {
	    
	    if ( firstLine == 0) {
	         SavedFile = SavedFile + line ;
                        firstLine = 1;
	     } else {
	         SavedFile = SavedFile + "\n" + line ;     
                   }
	}
	    
	    
	    
        }
	// Didnt find the key? Write it!
	if ( wroteKey == 0 && ! newKey.isEmpty())
	{
	    SavedFile = SavedFile + "\n" + newKey;
	}
	
        file.close();
    }
    
    
    // Save the new file
    QFile fileout( File );
    if ( fileout.open( QIODevice::WriteOnly ) ) {
        QTextStream streamout( &fileout );
                    streamout << SavedFile;
        fileout.close();
    }

}


QString wificonfigwidgetbase::getValue( QString File, QString Key, int occur )
{
int found = 1;
    
    QFile file( File );
    if ( file.open( QIODevice::ReadOnly ) ) {
        QTextStream stream( &file );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            
               // If the KEY is found in the line, continue processing 
	if ( line.indexOf(Key, 0) != -1 && line.indexOf("#", 0) != 0)
	{
	    if ( found == occur) {
	    
	    line.remove(line.indexOf(Key, 0), Key.length());
	       
	    
	    // Remove any quotes
	    if ( line.indexOf('"') == 0 )
	    {
		line = line.remove(0, 1);
	    }
	    
	    if ( line.indexOf('"') != -1  )
	    {
		line.truncate(line.lastIndexOf('"'));
	    }

	    return line;
	    
	    } else {
	       found++;  
	    }
	    
	    
	}
	    
	    
	    
        }
        file.close();
    }
    
    return "";
}

// Slot which moves a SSID higher in the connection priority
void wificonfigwidgetbase::slotMoveUp()
{
    QString tmpString;
    int tmpInt;
    bool tmpBool;
    int curRow = 1;
    bool MovedItem = false;

    // Check if we have a selection to work with
    if ( listWifi->currentRow() != -1 )
    {
      // Locate the SSID we want to remove
      QString editSSID = listWifi->item(listWifi->currentRow())->text();
      for ( int i = 0; i < 145; i++)
      {
          if ( SSIDList[i] == editSSID && i != 0 )
          {
            // We found the ssid we need to move up
            tmpString = SSIDList[i-1];
            SSIDList[i-1] = SSIDList[i] ; 
            SSIDList[i] = tmpString; 
            
            tmpInt = SSIDEncType[i-1];
            SSIDEncType[i-1] = SSIDEncType[i];
            SSIDEncType[i] = tmpInt;

            tmpBool = BSSID[i-1];
            BSSID[i-1] = BSSID[i];
            BSSID[i] = tmpBool;

            tmpString = WEPKey[i-1];
            WEPKey[i-1] = WEPKey[i];
            WEPKey[i] = tmpString;

            tmpInt = WEPIndex[i-1];
            WEPIndex[i-1] = WEPIndex[i];
            WEPIndex[i] = tmpInt;

            tmpBool = WEPHex[i-1];
            WEPHex[i-1] = WEPHex[i];
            WEPHex[i] = tmpBool;

            tmpString = WPAPersonalKey[i-1];
            WPAPersonalKey[i-1] = WPAPersonalKey[i];
            WPAPersonalKey[i] = tmpString;

            tmpString = WPAEIdent[i-1];
            WPAEIdent[i-1] = WPAEIdent[i];
            WPAEIdent[i] = tmpString;

            tmpString = WPAECACert[i-1];
            WPAECACert[i-1] = WPAECACert[i];
            WPAECACert[i] = tmpString;

            tmpString = WPAEClientCert[i-1];
            WPAEClientCert[i-1] = WPAEClientCert[i];
            WPAEClientCert[i] = tmpString;

            tmpString = WPAEPrivKeyFile[i-1];
            WPAEPrivKeyFile[i-1] = WPAEPrivKeyFile[i];
            WPAEPrivKeyFile[i] = tmpString;

            tmpString = WPAEPassword[i-1];
            WPAEPassword[i-1] = WPAEPassword[i];
            WPAEPassword[i] = tmpString;

            tmpInt = WPAEType[i-1];
            WPAEType[i-1] = WPAEType[i];
            WPAEType[i] = tmpInt;
            curRow=i-1;
            MovedItem=true;
            break;
          }
      }

      // Refresh the SSID list and enable the apply button
      if ( MovedItem) {
        slotRefreshSSIDList();
        pushApply->setEnabled(TRUE);
        listWifi->setCurrentRow(curRow);
      }
    }
}


// Slot which moves a SSID lower in the connection priority
void wificonfigwidgetbase::slotMoveDown()
{
    QString tmpString;
    int tmpInt;
    bool tmpBool;
    int curRow = 1;
    bool MovedItem = false;

    // Check if we have a selection to work with
    if ( listWifi->currentRow() != -1 )
    {
      // Locate the SSID we want to remove
      QString editSSID = listWifi->item(listWifi->currentRow())->text();
      for ( int i = 0; i < 145; i++)
      {
          if ( SSIDList[i] == editSSID && ! SSIDList[i+1].isEmpty())
          {
            // We found the ssid we need to move down
            tmpString = SSIDList[i+1];
            SSIDList[i+1] = SSIDList[i] ; 
            SSIDList[i] = tmpString; 
            
            tmpInt = SSIDEncType[i+1];
            SSIDEncType[i+1] = SSIDEncType[i];
            SSIDEncType[i] = tmpInt;

            tmpBool = BSSID[i+1];
            BSSID[i+1] = BSSID[i];
            BSSID[i] = tmpBool;

            tmpString = WEPKey[i+1];
            WEPKey[i+1] = WEPKey[i];
            WEPKey[i] = tmpString;

            tmpInt = WEPIndex[i+1];
            WEPIndex[i+1] = WEPIndex[i];
            WEPIndex[i] = tmpInt;

            tmpBool = WEPHex[i+1];
            WEPHex[i+1] = WEPHex[i];
            WEPHex[i] = tmpBool;

            tmpString = WPAPersonalKey[i+1];
            WPAPersonalKey[i+1] = WPAPersonalKey[i];
            WPAPersonalKey[i] = tmpString;

            tmpString = WPAEIdent[i+1];
            WPAEIdent[i+1] = WPAEIdent[i];
            WPAEIdent[i] = tmpString;

            tmpString = WPAECACert[i+1];
            WPAECACert[i+1] = WPAECACert[i];
            WPAECACert[i] = tmpString;

            tmpString = WPAEClientCert[i+1];
            WPAEClientCert[i+1] = WPAEClientCert[i];
            WPAEClientCert[i] = tmpString;

            tmpString = WPAEPrivKeyFile[i+1];
            WPAEPrivKeyFile[i+1] = WPAEPrivKeyFile[i];
            WPAEPrivKeyFile[i] = tmpString;

            tmpString = WPAEPassword[i+1];
            WPAEPassword[i+1] = WPAEPassword[i];
            WPAEPassword[i] = tmpString;

            tmpInt = WPAEType[i+1];
            WPAEType[i+1] = WPAEType[i];
            WPAEType[i] = tmpInt;
            curRow=i+1;
	    MovedItem=true;
            break;
          }
      }

      // Refresh the SSID list and enable the apply button
      if ( MovedItem) {
        slotRefreshSSIDList();
        pushApply->setEnabled(TRUE);
        listWifi->setCurrentRow(curRow);
       }

    }
}

void wificonfigwidgetbase::slotEditProfile()
{
    bool foundSSID=false;
    int curItem=0;

    // Check if we have a selection to work with
    if ( listWifi->currentRow() != -1 )
    {
      // Locate the SSID we want to remove
      QString editSSID = listWifi->item(listWifi->currentRow())->text();
      for ( int i = 0; i < 145; i++)
      {
          if ( SSIDList[i] == editSSID )
          {
            // We found the ssid we need to edit
            foundSSID=true; 
            curItem=i;
            break;
          }
      }

      // Lets go ahead and open the edit dialog on this SSID
      if (foundSSID)
      {
          // Set our internal flag that this is an edit on an existing device
          wifiselect = new wifiselectiondialog();
          wifiselect->init(DeviceName);

          // Check the type of SSID this is, and issue appropriate edit 
          if ( SSIDEncType[curItem] == NO_ENCRYPTION) {
             wifiselect->initEdit(SSIDList[curItem], BSSID[curItem]);
          }
          if ( SSIDEncType[curItem] == WEP_ENCRYPTION) {
             wifiselect->initEdit(SSIDList[curItem], BSSID[curItem], WEPKey[curItem], WEPIndex[curItem], WEPHex[curItem]);
          }
          if ( SSIDEncType[curItem] == WPA_ENCRYPTION) {
             wifiselect->initEdit(SSIDList[curItem], BSSID[curItem], WPAPersonalKey[curItem]);
          }
          if ( SSIDEncType[curItem] == WPAE_ENCRYPTION) {
             wifiselect->initEdit(SSIDList[curItem], BSSID[curItem], WPAEType[curItem], WPAEIdent[curItem], WPAECACert[curItem], WPAEClientCert[curItem], WPAEPrivKeyFile[curItem], WPAEPassword[curItem]);
          }


          // Connect our delete signal, which runs before we add a new SSID
          connect( wifiselect, SIGNAL( signalDeleteSSID(QString) ), this, SLOT( slotRemoveProfileSSID(QString) ) ); 

          // Connect our save signals
          connect( wifiselect, SIGNAL( signalSavedOpen(QString, bool) ), this, SLOT( slotAddNewProfileOpen(QString, bool) ) );
          connect( wifiselect, SIGNAL( signalSavedWEP( QString, bool, QString, int, bool ) ), this, SLOT( slotAddNewProfileWEP( QString, bool, QString, int, bool) ) );
   connect( wifiselect, SIGNAL( signalSavedWPA(QString, bool, QString) ), this, SLOT( slotAddNewProfileWPA(QString, bool, QString) ) );
   	  connect( wifiselect, SIGNAL( signalSavedWPAE(QString, bool, int, QString, QString, QString, QString, QString) ), this, SLOT ( slotAddNewProfileWPAE(QString, bool, int, QString, QString, QString, QString, QString) ) );

          wifiselect->exec();
      }


    }
}


void wificonfigwidgetbase::slotRemoveProfile()
{
    // Check if we have a selection to work with
    if ( listWifi->currentRow() != -1 )
    {
      // Locate the SSID we want to remove
      QString removeSSID = listWifi->item(listWifi->currentRow())->text();
      slotRemoveProfileSSID(removeSSID);

      // Refresh the SSID list and enable the apply button
      slotRefreshSSIDList();
      pushApply->setEnabled(TRUE);

    }
  
}

void wificonfigwidgetbase::slotAddNewProfile()
{
   wifiselect = new wifiselectiondialog();
   wifiselect->init(DeviceName);

   // Connect our save slots
   connect( wifiselect, SIGNAL( signalSavedOpen(QString, bool) ), this, SLOT( slotAddNewProfileOpen(QString, bool) ) ); 
   connect( wifiselect, SIGNAL( signalSavedWEP( QString, bool, QString, int, bool ) ), this, SLOT( slotAddNewProfileWEP( QString, bool, QString, int, bool) ) ); 
   connect( wifiselect, SIGNAL( signalSavedWPA(QString, bool, QString) ), this, SLOT( slotAddNewProfileWPA(QString, bool, QString) ) ); 
   connect( wifiselect, SIGNAL( signalSavedWPAE(QString, bool, int, QString, QString, QString, QString, QString) ), this, SLOT( slotAddNewProfileWPAE(QString, bool, int, QString, QString, QString, QString, QString) ) ); 

   wifiselect->exec();
}


void wificonfigwidgetbase::runCommand( QString Command )
{
              FILE *file = popen(Command.toLatin1(),"r"); 
	fclose(file);
}

void wificonfigwidgetbase::slotRemoveProfileSSID(QString RemoveSSID)
{
   bool foundSSID=false;

   // Loop through, remove selected SSID, and move any entries after it up
   for (int remItem = 0; remItem < 145; remItem++)
   {

     if ( RemoveSSID == SSIDList[remItem] ) {
       foundSSID=true;
     }

     if(foundSSID) 
     {
       SSIDList[remItem] = SSIDList[remItem+1] ; 
       SSIDEncType[remItem] = SSIDEncType[remItem+1];
       BSSID[remItem] = BSSID[remItem+1];
       WEPKey[remItem] = WEPKey[remItem+1];
       WEPIndex[remItem] = WEPIndex[remItem+1];
       WEPHex[remItem] = WEPHex[remItem+1];
       WPAPersonalKey[remItem] = WPAPersonalKey[remItem+1];
       WPAEIdent[remItem] = WPAEIdent[remItem+1];
       WPAECACert[remItem] = WPAECACert[remItem+1];
       WPAEClientCert[remItem] = WPAEClientCert[remItem+1];
       WPAEPrivKeyFile[remItem] = WPAEPrivKeyFile[remItem+1];
       WPAEPassword[remItem] = WPAEPassword[remItem+1];
       WPAEType[remItem] = WPAEType[remItem+1];
     }

     if ( SSIDList[remItem+1].isEmpty() )
     {
       break;
     }

   }

   
}

void wificonfigwidgetbase::slotAddNewProfileOpen(QString SSID, bool isBSSID)
{
   for (int dupItem = 0; dupItem < 145; dupItem++)
   {
      if ( SSID == SSIDList[dupItem] ) {
          QMessageBox::warning( this, tr("Error"), tr("You already have a wireless network with this SSID! Please remove it first.\n") );
          return;
      }
   }


   int curItem=0;

   while( ! SSIDList[curItem].isEmpty() && curItem < 145 )
   {
     curItem++;
   }

    // Find which current item we are working on

    SSIDList[curItem] = SSID;
    BSSID[curItem] = isBSSID;
    
    // Refresh the SSID listbox and enable the apply button
    slotRefreshSSIDList();
    slotCheckGlobalText();
}

void wificonfigwidgetbase::slotAddNewProfileWEP( QString SSID, bool isBSSID, QString newKey, int newIndex, bool hexkey )
{
   for (int dupItem = 0; dupItem < 145; dupItem++)
   {
      if ( SSID == SSIDList[dupItem] ) {
        QMessageBox::warning( this, tr("Error"), tr("You already have a wireless network with this SSID! Please remove it first.\n") );
        return;
      }
   }


   int curItem=0;

   while( ! SSIDList[curItem].isEmpty() && curItem < 145 )
   {
     curItem++;
   }

    // Find which current item we are working on
  
    SSIDList[curItem] = SSID;
    SSIDEncType[curItem] = WEP_ENCRYPTION;
    BSSID[curItem] = isBSSID;
    WEPKey[curItem] = newKey;
    WEPIndex[curItem] = newIndex;
    WEPIndex[curItem]--;
    WEPHex[curItem] = hexkey;

    // Refresh the SSID listbox and enable the apply button
    slotRefreshSSIDList();
    slotCheckGlobalText();

}


void wificonfigwidgetbase::slotAddNewProfileWPA( QString SSID, bool isBSSID, QString newKey )
{
   for (int dupItem = 0; dupItem < 145; dupItem++)
   {
      if ( SSID == SSIDList[dupItem] ) {
        QMessageBox::warning( this, tr("Error"), tr("You already have a wireless network with this SSID! Please remove it first.\n") );
        return;
      }
   }

   int curItem=0;

   while( ! SSIDList[curItem].isEmpty() && curItem < 145 )
   {
     curItem++;
   }


   SSIDList[curItem] = SSID;
   SSIDEncType[curItem] = WPA_ENCRYPTION;
   BSSID[curItem] = isBSSID;
   WPAPersonalKey[curItem] = newKey;
   
   // Refresh the SSID listbox and enable the apply button
   slotRefreshSSIDList();
   slotCheckGlobalText();
}


void wificonfigwidgetbase::slotAddNewProfileWPAE( QString SSID, bool isBSSID, int type, QString EAPIdent, QString CACert, QString ClientCert, QString PrivKeyFile, QString PrivKeyPass )
{

   for (int dupItem = 0; dupItem < 145; dupItem++)
   {
      if ( SSID == SSIDList[dupItem] ) {
        QMessageBox::warning( this, tr("Error"), tr("You already have a wireless network with this SSID! Please remove it first.\n") );
        return;
      }
   }

   int curItem=0;

   while( ! SSIDList[curItem].isEmpty() && curItem < 145 )
   {
     curItem++;
   }


   SSIDList[curItem] = SSID;
   SSIDEncType[curItem] = WPAE_ENCRYPTION;
   BSSID[curItem] = isBSSID;
   WPAEType[curItem] = type;
   WPAEIdent[curItem] = EAPIdent;
   WPAECACert[curItem] = CACert;
   WPAEClientCert[curItem] = ClientCert;
   WPAEPrivKeyFile[curItem] = PrivKeyFile;
   WPAEPassword[curItem] = PrivKeyPass;

   // Refresh the SSID listbox and enable the apply button
   slotRefreshSSIDList();
   slotCheckGlobalText();

}


void wificonfigwidgetbase::slotCheckDisabled()
{
	if ( checkDisableWireless->isChecked() ) 
        {
	    tabMainWidget->setEnabled(FALSE);
	} else {
	    tabMainWidget->setEnabled(TRUE);
	}
	
	 pushApply->setEnabled(TRUE); 
}


void wificonfigwidgetbase::slotOK()
{
    if ( pushApply->isEnabled() )
    {
        slotApply();
	sleep(1);
    }
        close();
}


void wificonfigwidgetbase::slotMACClicked()
{
   if ( checkMAC->isChecked() ) {
	groupMAC->setEnabled(FALSE);
   } else {
	groupMAC->setEnabled(TRUE);
   }
    pushApply->setEnabled(TRUE);
}


QString wificonfigwidgetbase::getLineFromCommandOutput( QString command )
{
	FILE *file = popen(command.toLatin1(),"r"); 
	
	char buffer[100];
	
	QString line = ""; 
	char firstChar;
	
	if ((firstChar = fgetc(file)) != -1){
		line += firstChar;
		line += fgets(buffer,100,file);
	}
	
	
	pclose(file);
	
	
	return line;
}


QString wificonfigwidgetbase::getNetmaskForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return ifr.netmaskAsString();
}


QString wificonfigwidgetbase::getOutErrorsForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return QString::number(ifr.errorsRx());
}


QString wificonfigwidgetbase::getOutPacketsForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return QString::number(ifr.packetsRx());
}


QString wificonfigwidgetbase::getInErrorsForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return QString::number(ifr.errorsTx());
}


QString wificonfigwidgetbase::getInPacketsForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return QString::number(ifr.packetsTx());
}


QString wificonfigwidgetbase::getStatusForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return ifr.mediaStatusAsString();
}


QString wificonfigwidgetbase::getMacForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return ifr.macAsString();
}


QString wificonfigwidgetbase::getIpForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return ifr.ipAsString();
}


QString wificonfigwidgetbase::getNameForIdent( QString ident )
{
   NetworkInterface ifr(ident);
   return ifr.desc();
}


void wificonfigwidgetbase::loadInfo()
{
  // Get all the device information for the info tab
  if ( textInfoName->text().isEmpty() ) {
  textInfoName->setText(getNameForIdent(DeviceName) );
  }


  textIP->setText(getIpForIdent(DeviceName) );
  textNetmask->setText(getNetmaskForIdent( DeviceName ) );
  textMac->setText(getMacForIdent( DeviceName ) );
  textStatus->setText(getStatusForIdent( DeviceName ) );
  textIPv6->setText(getIPv6ForIdent( DeviceName) );
  textGateway->setText(getGatewayForIdent(DeviceName) );
  textMedia->setText(getMediaForIdent(DeviceName ) );
  
  // Get the packet status for this device
  textPacketsIn->setText(getInPacketsForIdent( DeviceName) );
  textPacketsInErrors->setText( getInErrorsForIdent( DeviceName) );
  textPacketsOut->setText(getOutPacketsForIdent( DeviceName) );
  textPacketsOutErrors->setText(getOutErrorsForIdent( DeviceName) );

  // Connect the slot to refresh
  QTimer::singleShot(3000,  this,  SLOT(loadInfo() ) );
}


void wificonfigwidgetbase::showInfo()
{
     tabMainWidget->setCurrentWidget( tabMainWidget->widget(2) );
}


void wificonfigwidgetbase::slotFinishLoading()
{
    QString tmp, tmp2;
bool ok;

  // Get the ifconfig string
   tmp = getValue( "/etc/rc.conf", "ifconfig_" + DeviceName + "=", 1 );
   if ( tmp != "" ) {
   // If the device is setup, start loading the settings

   if ( tmp.indexOf("OFF") != -1 ) {
	   checkDisableWireless->setChecked(TRUE);
	   tabMainWidget->setEnabled(FALSE);
   } else if ( tmp.indexOf("inet") == -1 )
   {
      checkDHCP->setChecked(TRUE);
      lineNetmask->setText("255.255.255.0");
      slotCheckDHCPBox();
      
            // Look for the mac address change
	if ( tmp.indexOf("ether") != -1 ) {
		tmp2 = tmp;
		tmp2 = tmp2.remove(0, tmp.indexOf("ether") + 6 );
		//if ( tmp.indexOf(" ") != -1 ) {
		//  tmp2.truncate(tmp.indexOf(" ") );
		//}
		lineMAC->setText(tmp2);
		checkMAC->setChecked(FALSE);
		groupMAC->setEnabled(TRUE);
	} 


   } else if ( tmp.indexOf("inet") != -1 ) {
        // Get the IP address first
        tmp2 = tmp;
        tmp2 = tmp2.remove(0, tmp.indexOf("inet") + 5 );
        tmp2.truncate(tmp.indexOf("netmask") -1 );
        lineIP->setText(tmp2);

        // Look for the netmask
        if ( tmp.indexOf("netmask") != -1 ) {
           tmp2 = tmp;
           tmp2 = tmp2.remove(0, tmp.indexOf("netmask") + 8 );
           if ( tmp.indexOf("ether") != -1 ) {
              tmp2.truncate(tmp.indexOf("ether") );
           }

           lineNetmask->setText(tmp2);

        } else {
           // No netmask specified, default it instead
           lineNetmask->setText("255.255.255.0");
        }
   }

   
   // Look for the wpa_supplicant.conf file
   QFile file( "/etc/wpa_supplicant.conf" );
   if ( file.open( QIODevice::ReadOnly ) ) {
      int curItem=0;
      QTextStream stream( &file );
      QString line;
      while ( !stream.atEnd() ) {

            line = stream.readLine(); // line of text excluding '\n'

	    // Check if we are at the end of a network profile block
            if ( line.indexOf("}") == 0)
	    {
		curItem++;
	    }

 	    if ( line.indexOf(" ssid=") != -1 )
 	    {
		tmp2 = line.remove(0, line.indexOf("\"") +1 );
		tmp2.truncate(tmp2.indexOf("\"") );
		SSIDList[curItem] = tmp2;
		BSSID[curItem] = false;
		SSIDEncType[curItem]=NO_ENCRYPTION;
   	    }

 	    if ( line.indexOf(" bssid=") != -1 )
 	    {
		tmp2 = line.remove(0, line.indexOf("=") +1 );
		SSIDList[curItem] = tmp2;
		BSSID[curItem] = true;
		SSIDEncType[curItem]=NO_ENCRYPTION;
   	    }
	
	
 	    // Check if we are using a WEP key for this network
	    if ( line.indexOf("wep_key") != -1 )
	    {		       
                if (line.indexOf("\"") != -1 )
                {
		   tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		   tmp2.truncate(tmp2.indexOf("\""));
                   WEPHex[curItem]=false;
                } else {
		   tmp2 = line.remove(0, line.indexOf("=") + 1 );
                   WEPHex[curItem]=true;
                }
		// Save the keycode
		WEPKey[curItem] = tmp2;
		SSIDEncType[curItem]=WEP_ENCRYPTION;
 	    }

           // Check for the WEP tx key id
	   if ( line.indexOf("wep_tx_keyidx") != -1 )
	   {		       
		tmp2 = line.remove(0, line.indexOf("wep_tx_keyidx") +1 );
		// Save the keycode
		tmp2.truncate(tmp2.indexOf("=") );
		ok = tmp2.toInt(&ok);
		if ( ok ) {
		    WEPIndex[curItem] = tmp2.toInt(&ok);
		    WEPIndex[curItem]++;
		}
	   }
		  
           // Check if we are using WPA-Personal
	   if ( line.indexOf("psk=") != -1 )
	   {		       
		tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		tmp2.truncate( tmp2.indexOf("\"") );
			 
			
    	        // Save the keycode
		WPAPersonalKey[curItem] = tmp2;
		SSIDEncType[curItem]=WPA_ENCRYPTION;
	   }
		    
	   // Check if we are using WPA-Enterprise
           if ( line.indexOf("eap=") != -1 )
	   {		       
		tmp2 = line.remove(0, line.indexOf("=") + 1 );

		//Check to see whic type of WPA-Ent we are using
		if ( tmp2 == "TLS") {
		    WPAEType[curItem] = 1;
		} else if (tmp2 == "TTLS" ) {
		    WPAEType[curItem] = 2;
		} else if (tmp2 == "PEAP" ) {
		    WPAEType[curItem] = 3;
		}
			
		SSIDEncType[curItem]=WPAE_ENCRYPTION;
	   }
		    
           // Check for a identity= line
           if ( line.indexOf("identity=") != -1 )
	   {		       
		tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		tmp2.truncate( tmp2.indexOf("\"") );

		// Save the keycode
		WPAEIdent[curItem] = tmp2;
	   }
		    
	   // Check for a ca_cert= line
           if ( line.indexOf("ca_cert=") != -1 )
	   {		       
		tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		tmp2.truncate( tmp2.indexOf("\"") );

		// Save the keycode
		WPAECACert[curItem] = tmp2;
	   }
	
	   // Check for a client_cert= line
	   if ( line.indexOf("client_cert=") != -1 )
	   {		       
		tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		tmp2.truncate( tmp2.indexOf("\"") );

		// Save the keycode
		WPAEClientCert[curItem] = tmp2;
	   }
		    
          // Check for a private_key= line
           if ( line.indexOf("private_key=") != -1 )
	   {		       
		tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		tmp2.truncate( tmp2.indexOf("\"") );

		// Save the keycode
		WPAEPrivKeyFile[curItem] = tmp2;
	   }
	    
          // Check for a private_key_passwd= line
          if ( line.indexOf("private_key_passwd=") != -1 )
          {		       
		tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		tmp2.truncate( tmp2.indexOf("\"") );

		// Save the keycode
		WPAEPassword[curItem] = tmp2;
          }
	
         // Check for a private_key_passwd= line
         if ( line.indexOf("password=") != -1 )
         {		       
		tmp2 = line.remove(0, line.indexOf("\"") + 1 );
		tmp2.truncate( tmp2.indexOf("\"") );

		// Save the keycode
		WPAEPassword[curItem] = tmp2;
         }

      }

   }


   // Refresh the ssid profile list
   slotRefreshSSIDList();  
   
   // Start loading the info tab
   loadInfo();

   pushApply->setEnabled(FALSE);
   }
}


// Slot which reads the arrays and displays the list of WIFI profiles
void wificonfigwidgetbase::slotRefreshSSIDList()
{

  listWifi->clear();

  int curItem=0;

  while( ! SSIDList[curItem].isEmpty() )
  {
     if ( SSIDEncType[curItem] == NO_ENCRYPTION )
     {
       listWifi->addItem(new QListWidgetItem(QIcon(":object-unlocked.png"), SSIDList[curItem] ) );
     } else {

       listWifi->addItem(new QListWidgetItem(QIcon(":object-locked.png"), SSIDList[curItem] ) );
     }

     curItem++;

     // We only need 145 wireless networks
     if ( curItem > 145 )
     {
	break;
     }
  }

}


QString wificonfigwidgetbase::getIPv6ForIdent( QString ident )
{
	QString command = "nice ifconfig " +ident + " | grep \"inet6 \"";
	QString inputLine = getLineFromCommandOutput(command);
	QString ip= "";
	
	if (inputLine != "" && inputLine.indexOf("inet6 ") != -1){
		
		ip = inputLine.remove(0, inputLine.indexOf("inet6 ") + 5);
		ip.truncate(ip.indexOf("%"));
		
		
	}
	
	return ip;
}


QString wificonfigwidgetbase::getGatewayForIdent( QString ident )
{
        QString command = "nice netstat -n -r | grep \"default\" | grep " + ident;
	QString inputLine = getLineFromCommandOutput(command);
	QString packets = "";
	
	if (inputLine != "" ){
		inputLine = inputLine.simplified();
		packets = inputLine.section(' ', 1, 1 );
	}
	
	return packets;
}


QString wificonfigwidgetbase::getMediaForIdent( QString ident )
{
    	QString command = "nice ifconfig " +ident + " | grep \"media:\"";
	QString inputLine = getLineFromCommandOutput(command);
	QString status = "";
	
	if (inputLine != "" && inputLine.indexOf("media:") != -1){
		
		status = inputLine.remove(0, inputLine.indexOf("media:") + 7);
		status.truncate(inputLine.indexOf("\n") );
                if ( status.indexOf("(") != -1)
                {
                   status.remove(0, status.indexOf("(") + 1);
                }	
                if ( status.indexOf(")") != -1)
                {
                   status.truncate(status.indexOf(")"));
                }	
	}
	
	return status;
}


void wificonfigwidgetbase::slotCheckGlobalText()
{
    pushApply->setEnabled(TRUE);
}

