#ifndef WIFICONFIGWIDGETBASE_H
#define WIFICONFIGWIDGETBASE_H

#include <qfile.h>
#include <qmessagebox.h>
#include <qdialog.h>
#include <qwidget.h>
#include <pcbsd-netif.h>
#include <pcbsd-utils.h>
#include "wifiselectiondialog.h"
#include "wepconfig.h"
#include "dialogwpapersonal.h"
#include "dialogwpaenterprise.h"
#include "ui_wificonfigwidgetbase.h"
#include <QProcess>


// Setup our encryption type defines
#define NO_ENCRYPTION 0
#define WEP_ENCRYPTION 1
#define WPA_ENCRYPTION 2
#define WPAE_ENCRYPTION 3

class wificonfigwidgetbase : public QWidget, private Ui::wificonfigwidgetbase
{
        Q_OBJECT

public:
        wificonfigwidgetbase() : QWidget()
        {
          setupUi(this);
        }

    void setDevice( QString Device );
    void showInfo();

public slots:

private slots:
    void slotClose();
    void slotApply();
    void slotCheckDHCPBox();
    void slotAddNewProfile();
    void slotEditProfile();
    void slotRemoveProfile();
    void slotRemoveProfileSSID(QString RemoveSSID);
    void slotAddNewProfileOpen( QString SSID, bool isBSSID );
    void slotAddNewProfileWEP( QString SSID, bool isBSSID, QString newKey, int newIndex, bool hexkey );
    void slotAddNewProfileWPA( QString SSID, bool isBSSID, QString newKey );
    void slotAddNewProfileWPAE( QString SSID, bool isBSSID, int type, QString EAPIdent, QString CACert, QString ClientCert, QString PrivKeyFile, QString PrivKeyPass );
    void slotCheckDisabled();
    void slotOK();
    void slotMACClicked();
    void loadInfo();
    void slotFinishLoading();
    void slotCheckGlobalText();
    void slotRefreshSSIDList();
    void slotMoveUp();
    void slotMoveDown();

private:
    bool checkRange( QString IP );
    void saveValue( QString File, QString oldKey, QString newKey, int occur );
    QString getValue( QString File, QString Key, int occur );
    void runCommand( QString Command );
    QString getLineFromCommandOutput( QString command );
    QString getNetmaskForIdent( QString ident );
    QString getOutErrorsForIdent( QString ident );
    QString getOutPacketsForIdent( QString ident );
    QString getInErrorsForIdent( QString ident );
    QString getInPacketsForIdent( QString ident );
    QString getStatusForIdent( QString ident );
    QString getMacForIdent( QString ident );
    QString getIpForIdent( QString ident );
    QString getNameForIdent( QString ident );
    QString getIPv6ForIdent( QString ident );
    QString getGatewayForIdent( QString ident );
    QString getMediaForIdent( QString ident );
    QString DeviceName;
    wifiselectiondialog *wifiselect;
    QProcess *netifProc;

    // Lets define our arrays for the SSID profiles
    QString SSIDList[150];
    int SSIDEncType[150];
    bool BSSID[150];
    QString WEPKey[150];
    int WEPIndex[150];
    bool WEPHex[150];
    QString WPAPersonalKey[150];
    QString WPAEIdent[150];
    QString WPAECACert[150];
    QString WPAEClientCert[150];
    QString WPAEPrivKeyFile[150];
    QString WPAEPassword[150];
    int WPAEType[150];

signals:

} ;
#endif // WIFICONFIGWIDGETBASE_H

