#ifndef WIFISELECTIONDIALOG_H
#define WIFISELECTIONDIALOG_H

#include <qfile.h>
#include <qmessagebox.h>
#include <qdialog.h>
#include "wepconfig.h"
#include "dialogwpapersonal.h"
#include "dialogwpaenterprise.h"
#include "wifiscanssid.h"
#include "ui_wifiselectiondialog.h"

class wifiselectiondialog : public QDialog, private Ui::wifiselectiondialog
{
        Q_OBJECT

public:
        wifiselectiondialog() : QDialog()
        {
          setupUi(this);
        }

   void init(QString device);
   void scanWifi();
   void initEdit(QString selectedSSID, bool usingBSSID);
   void initEdit(QString selectedSSID, bool usingBSSID, QString editWEPKey, int editWEPIndex, bool editWEPHex);
   void initEdit(QString selectedSSID, bool usingBSSID, QString editWPAPersonalKey);
   void initEdit(QString selectedSSID, bool usingBSSID, int editWPAEType, QString editWPAEIdent, QString editWPAECACert, QString editWPAEClientCert, QString editWPAEPrivKeyFile, QString editWPAEPassword);


public slots:

private slots:
    void slotCancel();
    void slotConnect();
    void slotOpenWifiScan();
    void slotSSIDChanged(QString newSSID);
    void slotConfigWEP();
    void slotWEPChanged( QString newKey, int newIndex, bool hexkey );
    void slotCheckSecurityRadio();
    void slotCheckWhichSecurity();
    void slotConfigWPAP();
    void slotConfigWPAE();
    void slotWPAPChanged( QString newKey );
    void slotWPAEChanged( int type, QString EAPIdent, QString CACert, QString ClientCert, QString PrivKeyFile, QString PrivKeyPass );

private:
    QString DeviceName;
    QString SSID;
    QString EditingSSID;

    // Setup our dialogs
    wifiscanssid *dialogWifiscanssid;
    wepConfig *dialogWEP;
    dialogWPAPersonal *dialogWPAP;
    dialogWPAEnterprise *dialogWPAE;

    // WEP variables
    QString WEPKey;
    int WEPIndex;
    bool WEPHex;

    // WPA Personal Key variable
    QString WPAPersonalKey;

    // WPAE Variables
    int WPAEType;
    QString WPAEIdent;
    QString WPAECACert;
    QString WPAEClientCert;
    QString WPAEPrivKeyFile;
    QString WPAEPassword;

signals:
   void signalDeleteSSID(QString);
   void signalSavedOpen(QString, bool);
   void signalSavedWEP(QString, bool, QString, int, bool );
   void signalSavedWPA(QString, bool, QString);
   void signalSavedWPAE(QString, bool, int, QString, QString, QString, QString, QString);

} ;
#endif // WIFISELECTIONDIALOG_H

